# Generated by Django 4.0.3 on 2022-03-31 14:12

import django.db.models.deletion
from django.db import migrations, models
from django.db.migrations.operations.special import RunPython

import seawatch_registration.models


def forwards(apps, schema_editor):
    Application = apps.get_model("applications", "Application")
    PositionDecision = apps.get_model("applications", "PositionDecision")

    PositionDecision.objects.bulk_create(
        [
            PositionDecision(application=a, position=p)
            for a in Application.objects.all()
            for p in a.positions.all()
        ]
    )


def reverse(apps, schema_editor):
    PositionDecision = apps.get_model("applications", "PositionDecision")

    for pd in PositionDecision.objects.all():
        pd.application.positions.add(pd.position)


class Migration(migrations.Migration):

    dependencies = [
        ("seawatch_registration", "0033_alter_position_options"),
        ("applications", "0032_application_accepted"),
    ]

    operations = [
        migrations.CreateModel(
            name="PositionDecision",
            fields=[
                (
                    "id",
                    models.AutoField(
                        auto_created=True,
                        primary_key=True,
                        serialize=False,
                        verbose_name="ID",
                    ),
                ),
                (
                    "decision",
                    seawatch_registration.models.ShortTextField(
                        choices=[
                            ("open", "Open"),
                            ("reject", "Reject"),
                            ("accept", "Accept"),
                        ],
                        default="open",
                    ),
                ),
            ],
        ),
        migrations.AddField(
            model_name="application",
            name="position_decisions",
            field=models.ManyToManyField(
                related_name="+",
                through="applications.PositionDecision",
                to="seawatch_registration.position",
            ),
        ),
        migrations.AddField(
            model_name="positiondecision",
            name="application",
            field=models.ForeignKey(
                on_delete=django.db.models.deletion.CASCADE,
                related_name="+",
                to="applications.application",
            ),
        ),
        migrations.AddField(
            model_name="positiondecision",
            name="position",
            field=models.ForeignKey(
                on_delete=django.db.models.deletion.PROTECT,
                related_name="+",
                to="seawatch_registration.position",
            ),
        ),
        # Transfer the old relation to the through model
        RunPython(forwards, reverse),
        migrations.RemoveField(model_name="application", name="positions"),
        migrations.RenameField(
            model_name="application",
            old_name="position_decisions",
            new_name="positions",
        ),
        migrations.AlterField(
            model_name="application",
            name="positions",
            field=models.ManyToManyField(
                through="applications.PositionDecision",
                to="seawatch_registration.position",
            ),
        ),
    ]
